<?php

define("IN_MYBB", 1);

require_once "./global.php";

// Load language packs for this section
global $menu, $mybb, $lang, $db, $config;
$lang->load("maintenance");

checkadminpermissions("canrunmaint");
logadmin();

  if($mybb->input['action'] == "do_pwreset")
  {

	if(!isset($mybb->input['page']) || intval($mybb->input['page']) < 1)
	{
		$mybb->input['page'] = 1;
	}
	$page = intval($mybb->input['page']);
	if(!isset($mybb->input['perpage']) || intval($mybb->input['perpage']) < 1)
	{
		$mybb->input['perpage'] = 50;
	}
	$per_page = intval($mybb->input['perpage']);
	$start = ($page-1) * $per_page;
	$end = $start + $per_page;


	$query2 = $db->simple_select(TABLE_PREFIX."users", "COUNT(uid) as num_users");
	$num_users = $db->fetch_field($query2, 'num_users');


    $query = $db->simple_select(TABLE_PREFIX."users", "*", '', array('order_by' => 'uid', 'order_dir' => 'asc','limit_start' => $start, 'limit' => $per_page));


    while($user = $db->fetch_array($query)) 
    {

      if ($config['super_admins'] != $user['uid']){ 
         $password = random_str(10);
         $salt = generate_salt();
         $loginkey = generate_loginkey();
         $saltedpw = md5(md5($salt).md5($password));
          my_mail($user['email'], "You got a new password!", "Dear {$user['username']}
We have reset your password at {$mybb->settings['bbname']}.
Your new password is: {$password}.
You may change the password again if you wish.
Go to the forums in User CP -> Change Password.

Thanks you,
{$mybb->settings['bbname']} Staff

<a href=\"{$mybb->settings['bburl']}\">{$mybb->settings['bbname']}</a>.
                ");            

            $update_array = array(
                'password' => $saltedpw,
                'salt' => $salt,
                'loginkey' => $loginkey,
            );


            $db->update_query(TABLE_PREFIX."users", $update_array, "uid='{$user['uid']}'");
      }
    }
	if($end >= $num_users)
	{

        cpredirect("pwreset.php?".SID."&action=complete", "Passwords have been successfully reset and emailed.");
	}
	else
	{
		cpheader();
   	    startform("pwreset.php", "" , "do_pwreset");
    	starttable();
        tableheader("Reset Passwords");
		makelabelcode($lang->click_next_continue, '', 2);
		makehiddencode('page', ++$page);
		makehiddencode('perpage', $per_page);
		endtable();
		endform($lang->proceed);
		cpfooter();
	}
 
  }


  if($mybb->input['action'] == "complete")
  {
    cpheader();
    
    starttable();
    tableheader("Reset Passwords");
    makelabelcode("<div align=\"center\"><b>Congratulations!</b> Passwords have been successfully reset and emailed.</div>", '', 2);

	endtable();

}

  if($mybb->input['action'] == "")
  {
    cpheader();
    
    startform("pwreset.php", "" , "do_pwreset");
    starttable();
    tableheader("Reset Passwords");
    makelabelcode("<div align=\"center\">This will reset all but the superadmin password then email each member a new password.  Be wary of setting this too high.</div>", '', 2);
	makeinputcode("User to Process Per Page", 'perpage', 100);
	endtable();
	makehiddencode('page', 1);
    endform($lang->proceed);
}

?>